<?php
namespace AJAXGuestBook\controller;

use AJAXGuestBook\core\Captcha;
use AJAXGuestBook\core\Controller;
use AJAXGuestBook\core\Paginator;
use AJAXGuestBook\core\Session;

class Ajax extends Controller {
    function __construct(){
        parent::__construct();
    }

    public function entries(){
        $paginator = new Paginator;
        $paginator->items_total = $this->guestbook->getApprovedEntries();
        $paginator->mid_range = 5; // Number of pages to display. Must be odd and > 3
        $paginator->default_ipp = $this->guestbook->entriesPerPage;
        $paginator->paginate(URL . "/ajax/");

        $result["pages"] = $this->view->render("templates/pagination.html", ['paginator' => $paginator->page_data()]);
        if(isset($_GET["ipp"]) && $_GET["ipp"] == "All"){
            $result["entries"] = $this->view->render("home/entries.html", ['messages' => $this->guestbook->loadEntries(0, 0, true)]);
        } else{
            $result["entries"] = $this->view->render("home/entries.html", ['messages' => $this->guestbook->loadEntries($paginator->low, $paginator->items_per_page)]);
        }
        $result = utf8ize($result);
        echo json_encode($result, JSON_UNESCAPED_UNICODE);
        return;
    }

    public function entriesarray(){
        $paginator = new Paginator;
        $paginator->items_total = $this->guestbook->getApprovedEntries();
        $paginator->mid_range = 5; // Number of pages to display. Must be odd and > 3
        $paginator->default_ipp = $this->guestbook->entriesPerPage;
        $paginator->paginate(URL . "/ajax/");

        $pages = $paginator->page_data();
        $pages = array_filter($pages, function($k) {
            return in_array($k,['currentpage','totalpages']);
        }, ARRAY_FILTER_USE_KEY);
        $result["pages"] = $pages;

        if(isset($_GET["ipp"]) && $_GET["ipp"] == "All"){
            $result["entries"] = $this->guestbook->loadEntries(0, 0, true);
        } else{
            $result["entries"] = $this->guestbook->loadEntries($paginator->low, $paginator->items_per_page);
        }
        $result = utf8ize($result);
        echo json_encode($result, JSON_UNESCAPED_UNICODE);
        return;
    }

    public function addentry(){
      /*$response['error'] = 'Just an error test!!';
      echo json_encode($response);
      return;*/

        $entriesModel = $this->loadModel('EntriesModel', true);
        $result = $entriesModel->addEntry();
        if(isset($result['error'])){
            Session::set("gberror", $result['error']);
            $response['error'] = $this->getAjaxErrorList();
            echo json_encode($response);
        } else if(isset($result['success'])){
            $response['success'] = $result['success'];
            echo json_encode($response);
        }
        return;
    }

    public function captcha(){
        $captcha = new Captcha;
        $captcha->fontdir = ROOTPATH . DS . "public" . DS . "fonts" . DS;
        $captcha->font = "lucon.ttf";
        $captcha->getImage();
    }

    public function verifycaptcha(){
        $response = [];
        if(isset ($_POST ['captchacode']) && $_SESSION ['captchacode'] != null){
            if($_SESSION ['captchacode'] === trim($_POST ['captchacode'])){
                $response["success"] = true;
            } else {
                $response["error"] = true;
            }
        }
        echo json_encode($response);
        return;
    }

    function getAjaxErrorList(){
        return $this->view->render("templates/ajaxerrorlist.html", []);
    }
}