<?php
namespace AJAXGuestBook\controller;

use AJAXGuestBook\core\Controller;
use AJAXGuestBook\core\Paginator;
use AJAXGuestBook\core\GBLocale;
use AJAXGuestBook\core\Validation;

class Home extends Controller {
    function __construct(){
        parent::__construct();
    }

    public function index(){
        $paginator = new Paginator();
        $paginator->items_total = $this->guestbook->getApprovedEntries();
        $paginator->mid_range = 5; // Number of pages to display. Must be odd and > 3
        $paginator->default_ipp = $this->guestbook->entriesPerPage;
        $paginator->paginate(URL . "/entries/");
        if(isset($_GET['ipp']) and $_GET['ipp'] == 'All'){
            $messages = $this->guestbook->loadEntries(0, 0, true);
        } else{
            $messages = $this->guestbook->loadEntries($paginator->low, $paginator->items_per_page);
        }

        echo $this->view->render('home/index.html', ['minMessage' => $this->guestbook->minCommentsChars,
                                                     'maxMessage' => $this->guestbook->maxCommentsChars,
                                                     'emcodes' => json_encode($this->guestbook->emoticon->getEmoticonCodeList()),
                                                     'emfiles' => json_encode($this->guestbook->emoticon->getEmoticonFileList()),
                                                     'smileys' => $this->guestbook->emoticon->getEmoticonSrcList(),
                                                     'messages' => $messages, 'paginator' => $paginator->page_data(),
                                                     'querystring' => parse_url($_SERVER['REQUEST_URI'], PHP_URL_QUERY),
                                                     'requiredfields' => $this->guestbook->requiredFields,
                                                     'captcha' => $this->guestbook->captcha,
                                                     'post' => $_POST]);
    }

    public function welcome(){
        $testEntry = $this->guestbook->loadGBEntry('mid011687g123456');
        if(isset($testEntry['data'])){
            $testEntry = json_decode($testEntry['data']);
            echo $this->view->render('home/welcome.html', ['messages' => array($testEntry)]);
        } else {
            header('Location: ' . URL);
        }

    }

    public function vtest(){

        //call_user_func("\AJAXGuestBook\core\Validation::myTranslator","test");

        $res = Validation::testVal('asif 6');
        if($res === true){
            echo "all ok";
        } else {
            var_dump($res);
        }

    }
}
