<?php
namespace AJAXGuestBook\controller;

use AJAXGuestBook\core\{Controller, Session, Auth};

class Login extends Controller {
    function __construct(){
        parent::__construct();
        $this->title .= " - Administrator Login";
        if(!Session::get("returnurl")){
            Session::set("returnurl", urlencode(URL . '/admin'));
        }
    }

    public function index(){
        if(Auth::checkLogin() === true){
            header('Location: ' . urldecode(Session::getanddelete("returnurl")));
            exit();
        }
        echo $this->view->render('admin/login.html', ['title' => $this->title, 'post' => $_POST]);
    }

    public function authenticate(){
        if(Auth::checkLogin() === true){
            header('Location: ' . urldecode(Session::getanddelete("returnurl")));
            exit();
        }
        $loginModel = $this->loadModel('LoginModel');
        $authuser = $loginModel->checkLogin($this->guestbook->adminid, $this->guestbook->pass);
        if(!$authuser){
            echo $this->view->render('admin/login.html', ['title' => $this->title, 'post' => $_POST]);
            return;
        }
        if($authuser === true){
            header('Location: ' . urldecode(Session::getanddelete("returnurl")));
            exit();
        }
    }

    public function logout(){
        $loginModel = $this->loadModel('LoginModel');
        $loginModel->logout();
    }
}

