<?php
namespace AJAXGuestBook\controller;

use AJAXGuestBook\core\Auth;
use AJAXGuestBook\core\Controller;
use AJAXGuestBook\core\Session;

class Upgrade extends Controller {
    function __construct(){
        parent::__construct();
        $this->title .= " - Upgrade";
        Auth::handleLogin();
    }

    public function index($param = null){
        if(isset($param)){
            $this->errorpage();
            return;
        }
        echo $this->view->render('upgrade/index.html', ['title' => $this->title]);
    }

    public function database($action = null, $param = null){
        if(isset($param)){
            $this->errorpage();
            return;
        }
        if(isset($action)){
            switch($action){
                /*case "check":
                    $upgrademodel = $this->loadModel('UpgradeModel',true);
                    break;*/ case "import":
                if(GBDEMO){
                    Session::set('gberror', 'Not working in Demo mode.');
                }
                if(isset($_POST['submit']) && !GBDEMO){
                    $upgrademodel = $this->loadModel('UpgradeModel', true);
                    $upgraderesult = $upgrademodel->importOldDatabase();
                    if(isset($upgraderesult['error'])){
                        Session::set('gberror', $upgraderesult['error']);
                    } elseif(isset($upgraderesult['success'])){
                        Session::set('gbsuccess', $upgraderesult['success']);
                    } elseif(isset($upgraderesult['info'])){
                        Session::set('gbinfo', $upgraderesult['info']);
                    }
                }
                break;
                default:
                    $this->errorpage();
                    return;
                    break;
            }
        }
        echo $this->view->render('upgrade/index.html', ['title' => $this->title]);
    }
}