<?php
namespace AJAXGuestBook\controller;

use AJAXGuestBook\core\Controller;
use AJAXGuestBook\core\Paginator;
use AJAXGuestBook\core\Session;
use AJAXGuestBook\core\Captcha;

class Widget extends Controller {
    function __construct(){
        parent::__construct();
    }

    public function index($param = null){
        if(isset($param)){
            $this->errorpage();
            return;
        }
        $this->renderEntries();
    }

    public function addentry(){
        $entriesModel = $this->loadModel('EntriesModel', true);
        $result = $entriesModel->addEntry();
        if(isset($result['error'])){
            Session::set("gberror", $result['error']);
            $this->renderEntries();
        } else if(isset($result['success'])){
            Session::set("gbsuccess", $result['success']);
            header('Location: ' . URL . '/');
            exit();
        }
    }

    public function renderEntries(){
        $paginator = new Paginator();
        $paginator->items_total = $this->guestbook->getApprovedEntries();
        $paginator->mid_range = 5; // Number of pages to display. Must be odd and > 3
        $paginator->default_ipp = $this->guestbook->entriesPerPage;
        $paginator->paginate(URL . "/entries/");
        if(isset($_GET['ipp']) and $_GET['ipp'] == 'All'){
            $messages = $this->guestbook->loadEntries(0, 0, true);
        } else{
            $messages = $this->guestbook->loadEntries($paginator->low, $paginator->items_per_page);
        }

        echo $this->view->render('home/index.html', ['minMessage' => $this->guestbook->minCommentsChars,
                                                     'maxMessage' => $this->guestbook->maxCommentsChars,
                                                     'emcodes' => json_encode($this->guestbook->emoticon->getEmoticonCodeList()),
                                                     'emfiles' => json_encode($this->guestbook->emoticon->getEmoticonFileList()),
                                                     'smileys' => $this->guestbook->emoticon->getEmoticonSrcList(),
                                                     'messages' => $messages, 'paginator' => $paginator->page_data(),
                                                     'querystring' => parse_url($_SERVER['REQUEST_URI'], PHP_URL_QUERY),
                                                     'requiredfields' => $this->guestbook->requiredFields,
                                                     'captcha' => $this->guestbook->captcha, 'post' => $_POST]);
    }

    public function captcha(){
        $captcha = new Captcha;
        $captcha->fontdir = ROOTPATH . DS . "public" . DS . "fonts" . DS;
        $captcha->font = "lucon.ttf";
        $captcha->getImage();
    }
}
