<?php
namespace AJAXGuestBook\core;

class Badwords {
    /* Load the badwords to mask it. */
    public static function loadBadwords($bwfile){
        if(!is_file(DATAPATH . DS . $bwfile)){
            return false;
        } else{
            $badWordsFH = fopen(DATAPATH . DS . $bwfile, "r");
            $badwords = explode("\n", @fread($badWordsFH, filesize(DATAPATH . DS . $bwfile)));
            fclose($badWordsFH);
            for($bw = 0; $bw < count($badwords); $bw++){
                $badwords[$bw] = str_replace("\r", "", $badwords[$bw]);
            }
            return $badwords;
        }
    }

    /* Load the badwords list for admin editing. */
    public static function loadBadwordsList($bwfile){
        if(!is_file(DATAPATH . DS . $bwfile)){
            $returnvalue['error'] = "Error loading badwords file. Please type in the words you want to filter out and click save. New file will be automatically created.";
        } else{
            $badWordsFH = @fopen(DATAPATH . DS . $bwfile, "r");
            $bwlist = @fread($badWordsFH, filesize(DATAPATH . DS . $bwfile));
            fclose($badWordsFH);
            $returnvalue['data'] = $bwlist;
        }
        return $returnvalue;
    }

    /* Save the badwords list edited. */
    public static function saveBadwordsList($bwfile){
        $badWordsFH = @fopen(DATAPATH . DS . $bwfile, "w");
        if($badWordsFH === false){
            $returnvalue['error'] = 'Error saving to  badwords file.';
            return $returnvalue;
        }
        $bwlist = filter_var(trim($_POST['taBadwords']), FILTER_SANITIZE_STRING);
        $bwlist = preg_replace('/\s+/', ' ', $bwlist);
        $bwlist = str_replace(' ', "\n", $bwlist);
        fwrite($badWordsFH, $bwlist);
        fclose($badWordsFH);
        $returnvalue['success'] = 'Saved Badwords list.';
        $returnvalue['data'] = $bwlist;
        return $returnvalue;
    }
}