<?php
namespace AJAXGuestBook\core;

use HTMLPurifier;
use HTMLPurifier_Config;

class CommentPurifier {
    public static function purify($comment){
        $config = HTMLPurifier_Config::createDefault();
        $config->set('HTML.AllowedElements', array('b', 'strong', 'ul', 'ol', 'li', 'em', 'del', 'hr', 'blockquote',
                                                   'a', 'br', 'p', 'h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'i', 'u', 'dl',
                                                   'dt', 'dd', 'img', 'span', 'font'));
        $config->set('HTML.AllowedAttributes', array('a.href', 'a.target', 'img.src', 'img.alt', '*.style', '*.class', 'font.size'));
        $purifier = HTMLPurifier::getInstance($config);
        return $purifier->purify($comment);
    }
}