<?php
namespace AJAXGuestBook\core;

use AJAXGuestBook\models\{AdminModel, EntriesModel, InstallModel, LoginModel, UpgradeModel};

class Controller {
    public $title = "AJAX Guestbook";
    public $navtitle = "AJAX Guestbook";
    public $guestbook;
    protected $view;

    function __construct(){
        $is_admin = (Auth::checkLogin() === true);
        $this->guestbook = GuestBook::getInstance();
        $this->title = $this->guestbook->title;
        define("GBLANG", $this->guestbook->language);

        $this->view = new View($this->guestbook->theme);
        $this->view->addGlobals('website', $this->guestbook->website);
        $this->view->addGlobals('company', $this->guestbook->company);
        $this->view->addGlobals('title', $this->guestbook->title);
        $this->view->addGlobals('navtitle', $this->guestbook->title);
        $this->view->addGlobals('isadmin', $is_admin);
        $this->view->addGlobals('ismobile', ISMOBILE);
        $this->view->addGlobals('lang', utf8ize(GBLocale::getLanguageVariables()));
    }

    public function loadModel($model_name, $gbadapter = false){
        // return new model
        $model = "AJAXGuestBook\models\\$model_name";
        if(!$gbadapter){
            return new $model();
        } else{
            return new $model($this->guestbook);
        }
    }

    public function errorpage(){
        $this->title .= " - Page Not Found";
        header('HTTP/1.0 404 Not Found');
        echo $this->view->render('404.html', ['title' => $this->title]);
    }
}
