<?php
namespace AJAXGuestBook\core;

use Carbon\Carbon;
use DateTime;
use DateTimeZone;

final class GBLocale {
    public static function getTimeZoneList(){
        return DateTimeZone::listIdentifiers(DateTimeZone::ALL);
    }

    public static function convertUTCTimetoTIMEZONETime($time, $timezone, $lang){
        $ctime = Carbon::createFromTimestampUTC($time)->locale($lang)->setTimezone($timezone);
        //$entrytime = $ctime->formatLocalized('%a, %b %d, %Y, %I:%M %p');
        $entrytime = $ctime->isoFormat('MMMM Do YYYY, h:mm:ss a');
        return $entrytime;
    }

    public static function getHumanDiff($time, $timezone, $lang){
        $ctime = Carbon::createFromTimestampUTC($time)->locale($lang)->setTimezone($timezone);
        $entrytime = $ctime->diffForHumans();// ## days ago
        return $entrytime;
    }

    /*public static function getLocaleList(){
        $localecodes = IntlCalendar::getAvailableLocales();
        $localesnames = array_map(function(&$loc){return $loc = Locale::getDisplayName($loc, $loc);}, $localecodes);
        $localist = array_combine($localecodes, $localesnames);
        $localist = array_filter($localist, function($key) { return strpos($key, '_') !== false; }, ARRAY_FILTER_USE_KEY);
        return $localist;
    }*/
    public static function getCarbonLocales(){
        $cblang = require VENDOR . DS . 'nesbot' . DS . 'carbon' . DS . 'src' . DS . 'Carbon' . DS . 'List' . DS . 'languages.php';
        $carbonlocales = Carbon::getAvailableLocales();
        $result = [];
        foreach($carbonlocales as $locale){
            if(isset($cblang[$locale])){
                $result[$locale] = $cblang[$locale];
            }
        }
        return $result;
    }

    public static function convertOldDateTimetoTimeStamp($datetime){
        $dateTimeObject = DateTime::createFromFormat('D, M d, Y, H:i A', $datetime);
        return $dateTimeObject->getTimestamp();
    }

    public static function getLanguageVariables($section = null){
        $langvars = require LANGPATH . DS . "en.php";
        if(defined('GBLANG') && GBLANG !== "en"){
            if(file_exists(LANGPATH . DS . GBLANG . ".php")){
                $langvars = array_replace_recursive($langvars, require LANGPATH . DS . GBLANG . ".php");
            }
        }
        if(isset($section)){
            $langsection = [];
            foreach($section as $sec){
                $langsection[$sec] = $langvars[$sec];
            }
            return $langsection;
        }
        return $langvars;
    }
}