<?php
namespace AJAXGuestBook\core;

class GuestbookBookExtension extends \Twig\Extension\AbstractExtension implements \Twig\Extension\GlobalsInterface {
    public function getGlobals(){
        return ['URL' => URL,];
    }

    public function getFunctions(){
        return [new \Twig\TwigFunction('setsession', [Session::class, 'set']),
                new \Twig\TwigFunction('getsession', [Session::class, 'get']),
                new \Twig\TwigFunction('deletesession', [Session::class, 'delete']),
                new \Twig\TwigFunction('getsessionanddelete', [Session::class, 'getanddelete']),
                new \Twig\TwigFunction('setcheckboxval', [$this, 'setCheckBoxValue']),];
    }

    public function getFilters(){
        return [new \Twig\TwigFilter('url_decode', array($this, 'urlDecodeFilter')),
                new \Twig\TwigFilter('textExcerpt', array($this, 'textExcerpt'))];
    }

    public function urlDecodeFilter($url){
        return urldecode($url);
    }

    function setCheckBoxValue($val, $bool = false){
        if(intval($val) == 1 && !$bool){
            return "checked";
        }
        if($val == "true" && $bool){
            return "checked";
        }
        return false;
    }

    public function textExcerpt($text){
        $max_length = 100;
        $keep_word = true;

        //$text = strip_tags($text);
        $text = $this->rip_tags($text);
        $text = html_entity_decode($text);

        if(strlen($text) <= $max_length) {
            return $text;
        }

        if(strlen($text) > $max_length) {
            if($keep_word) {
                $text = mb_substr($text, 0, $max_length + 1);

                if($last_space = strrpos($text, ' ')) {
                    $text = mb_substr($text, 0, $last_space);
                    $text = rtrim($text);
                }
            } else {
                $text = mb_substr($text, 0, $max_length);
                $text = rtrim($text);
            }
        }
        return $text;
    }

    function rip_tags($string) {

        // ----- remove HTML TAGs -----
        $string = preg_replace ('/<[^>]*>/', ' ', $string);

        // ----- remove control characters -----
        $string = str_replace("\r", '', $string);    // --- replace with empty space
        $string = str_replace("\n", ' ', $string);   // --- replace with space
        $string = str_replace("\t", ' ', $string);   // --- replace with space

        // ----- remove multiple spaces -----
        $string = trim(preg_replace('/ {2,}/', ' ', $string));

        return $string;

    }
}