<?php
namespace AJAXGuestBook\core;

final class Logger {
    private static $filename = APPPATH . DS . 'development.log';

    public static function log($message){
        Logger::write_log($message, true, true);
    }

    public static function request(){
        $headers = getallheaders();
        Logger::write_log("REQUEST:", true);
        Logger::write_log($headers);
        $get_params = $_GET;
        if($get_params){
            Logger::write_log("GET parameters:");
            Logger::write_log($get_params);
        }
        $post_params = $_POST;
        if($post_params){
            Logger::write_log("POST parameters:");
            Logger::write_log($post_params, false, true);
        }
    }

    public static function session(){
        $session_params = $_SESSION;
        if($session_params){
            Logger::write_log("SESSION parameters:");
            Logger::write_log($session_params);
        }
    }

    private static function write_log($message, $sepopen = false, $sepclose = false){
        //$message can either be a string or an array
        if(file_exists(self::$filename)){
            $fd = fopen(self::$filename, 'a');
        } else{
            $fd = fopen(self::$filename, 'w');
        }
        //$fd = fopen($this->filename, 'a');
        if($sepopen === true){
            fwrite($fd, "Time " . strftime("%d/%m/%Y  %I:%M %p") . "\n");
            fwrite($fd, "------------------------------------------------------------------------------\n");
        }
        if(is_array($message)){
            Logger::write_array($message, $fd);
        } else{
            Logger::write_string($message, $fd);
        }
        if($sepclose === true){
            fwrite($fd, "\n");
        }
        fclose($fd);
    }

    private static function write_string($message, $fd){
        fwrite($fd, $message . "\n");
    }

    private static function write_array($message, $fd){
        foreach($message as $key => $value){
            if(is_array($value)){
                fwrite($fd, $key . "{ ");
                Logger::write_array($value, $fd);
                fwrite($fd, " }\n");
            } else{
                $string = "\t {" . $key . ': ' . $value . "}\n ";
                fwrite($fd, $string);
            }
        }
    }
}