<?php
namespace AJAXGuestBook\core;

class Session {
    public static function init(){
        if(session_id() == ''){
            session_start();
        }
    }

    public static function set($key, $value){
        $_SESSION[$key] = $value;
    }

    public static function get($key){
        if(isset($_SESSION[$key])){
            return $_SESSION[$key];
        } else{
            return false;
        }
    }

    public static function delete($key){
        unset($_SESSION[$key]);
    }

    public static function getanddelete($key){
        if(isset($_SESSION[$key])){
            $result = $_SESSION[$key];
            unset($_SESSION[$key]);
            return $result;
        } else{
            return false;
        }
    }

    public static function clear(){
        $_SESSION = array();
    }

    public static function destroy(){
        // Unset all of the session variables.
        $_SESSION = array();
        // If it's desired to kill the session, also delete the session cookie.
        // Note: This will destroy the session, and not just the session data!
        if(ini_get("session.use_cookies")){
            $params = session_get_cookie_params();
            setcookie(session_name(), '', time() - 42000, $params["path"], $params["domain"], $params["secure"], $params["httponly"]);
        }
        // Finally, destroy the session.
        session_destroy();
    }
}
