<?php

use AJAXGuestBook\core\Logger;

function setCheckBoxVal($val, $bool = false){
    if(intval($val) == 1 && !$bool){
        echo "checked";
    }
    if($val == "true" && $bool){
        echo "checked";
    }
}

function utf8ize($mixed){
    if(is_array($mixed)){
        foreach($mixed as $key => $value){
            $mixed[$key] = utf8ize($value);
        }
    } elseif(is_string($mixed)){
        return mb_convert_encoding($mixed, "UTF-8");
    }
    return $mixed;
}

function settingsError(){
    $errorval = "There was error loading the guestbook settings.<br>";
    $errorval .= "Please make sure that the settings file is present in its appropriate folder.<br>";
    $errorval .= "Also make sure the settings file is in proper format and not tampered.<br>";
    $errorval .= "Contact the guestbook owner and inform about the error.";
    return $errorval;
}

function scriptVersion(){
    return GBSCRIPT_VERSION;
}

function writehtaccess(){
    $fp = fopen('.htaccess', 'a+');
    if($fp){
        fwrite($fp, "
                Options -MultiViews
                RewriteEngine On
                Options -Indexes

                RewriteCond %{REQUEST_FILENAME} !-d
                RewriteCond %{REQUEST_FILENAME} !-f
                RewriteCond %{REQUEST_FILENAME} !-l

                RewriteRule ^(.+)$ index.php?url=$1 [QSA,L]");
        fclose($fp);
    }
}

function trace_log(){
    $tracelines = "";
    foreach(debug_backtrace() as $trace){
        $tracelines .= sprintf("\n%s:%s %s::%s", $trace['file'], $trace['line'], $trace['class'], $trace['function']);
    }
    Logger::log($tracelines);
}

// Return application base url
function appURL(){
    $app_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]" . URL;
    return $app_url;
}

function getThemeList(){
    $themelist = glob(VIEWS . DS . '*' , GLOB_ONLYDIR);
    return array_map('basename', $themelist);
}