<?php
namespace AJAXGuestBook\models;

use AJAXGuestBook\core\Session;
use PasswordHash;

class LoginModel {
    private $error;
    private $passhash;
    private $adminid;
    private $pass;

    function __construct(){
        $this->error = false;
    }

    public function checkLogin($adminid, $pass){
        $this->adminid = $adminid;
        $this->pass = $pass;
        if(!isset($_POST['userid']) OR empty($_POST['userid'])){
            $this->error = true;
            Session::set("usererror", "User ID cannot be blank");
        } else{
            $userid = trim(filter_input(INPUT_POST, 'userid', FILTER_SANITIZE_STRING));
        }
        if(!isset($_POST['password']) OR empty($_POST['password'])){
            $this->error = true;
            Session::set("passerror", "Password cannot be blank");
        } else{
            $password = trim(filter_input(INPUT_POST, 'password', FILTER_SANITIZE_STRING));
        }
        if($this->error){
            Session::set("loginerror", "Please correct the errors below.");
            return false;
        }
        if(strcmp($this->adminid, $userid) != 0){
            Session::set("loginerror", "Invalid admin ID or password.");
            return false;
        } else{
            $this->passhash = new PasswordHash(8, true);
            if($this->passhash->CheckPassword($password, $this->pass)){
                Session::set("timeout", time());
                Session::set("admin_logged_in", true);
                Session::set("adminid", $userid);
                return true;
            } else{
                Session::set("loginerror", "Invalid User ID or password.");
                return false;
            }
        }
    }

    public function logout(){
        Session::destroy();
        header('Location: ' . URL . '/login');
        exit();
    }
}
