<?php
namespace AJAXGuestBook\models;

use AJAXGuestBook\core\GBUpgrader;
use AJAXGuestBook\core\Model;
use AJAXGuestBook\core\Session;
use Exception;

class UpgradeModel extends Model {
    private $gbupgrader;

    function __construct(){
        parent::__construct();
        $this->gbupgrader = new GBUpgrader();
    }

    public function upgradeOldDatabase(){
        if(file_exists(DATAPATH . DS . "olddata.xml")){
            rename(DATAPATH . DS . "olddata.xml", DATAPATH . DS . "data.xml");
            if($this->gbupgrader->upgradedbv4()){
                return true;
            } else{
                rename(DATAPATH . DS . "data.xml", DATAPATH . DS . "olddata.xml");
                return false;
            }
        } else{
            Session::set("gberror", "Could not find olddata.xml at " . DATAPATH . DS . "olddata.xml. Missing the old backup database file.");
            return false;
        }
    }

    public function importOldDatabase(){
        try{
            if(!isset($_FILES['dbfile']) || (isset($_FILES['dbfile']) && $_FILES["dbfile"]["error"] == UPLOAD_ERR_NO_FILE)){
                throw new Exception('No files found for upload. Please select the file to import.');
            }
            $dbdoc = $_FILES['dbfile'];
            $ext = explode('.', basename($dbdoc['name']));
            $ext = array_pop($ext);
            if($ext != "xml"){
                throw new Exception('Invalid file selected. Please select a valid xml file to import.');
            }
            $target = DATAPATH . DS . "importdata.xml";
            if(!move_uploaded_file($dbdoc['tmp_name'], $target)){
                throw new Exception('Error moving uploaded file. Contact the system administrator.');
            }
            $this->gbupgrader->setDatabaseFile("importdata.xml");
            $result = $this->gbupgrader->upgradedbv4();
            if(isset($result['success'])){
                if(file_exists(DATAPATH . DS . "data.xml")){
                    if(!unlink(DATAPATH . DS . "data.xml")){
                        throw new Exception('Error deleting old database file. Contact the system administrator.');
                    }
                }
                if(!rename(DATAPATH . DS . "importdata.xml", DATAPATH . DS . "data.xml")){
                    throw new Exception('Error renaming new imported file. Contact the system administrator.');
                }
                return $result;
            } else{
                if(isset($result['info'])) unlink(DATAPATH . DS . "importdata.xml");
                return $result;
            }
        } catch(Exception $e){
            $returnvalue['error'] = $e->getMessage();
            return $returnvalue;
        }
    }
}