new Vue({
    delimiters: ['${', '}'],
    el: '#q-app',
    data(){
        return {
            currentPage: 1,
            ipp: paginator['itemsperpage'],
            paginator: paginator,
            messages: JSON.parse(messagearray),
            gbform : {
                fullname: "",
                email: "",
                website: "",
                comments: "",
                captchacode: "",
                addentry: true
            },
            formerrors : {
                fullname : {isValid : true, message : ''},
                email : {isValid : true, message : ''},
                website : {isValid : true, message : ''},
                comments : {isValid : true, message : ''},
                captchacode : {isValid : true, message : ''}
            },
            loadingState: false,
            requiredFileds: requiredFileds,
            captchaVerified: false,
            notifyhandler: null,
            captchaurl: ''
        }
    },
    methods: {
        loadGuestbookPage(page){
            this.messages = [];
            this.loadingState = true;
            axios.get(gbURL + '/Ajax/entriesarray', {
                params: {
                    page: page,
                    ipp: this.ipp
                },
                responseType: 'json'
            }).then((response) => {
                this.messages = response.data.entries;
                this.paginator = response.data.pages;
                this.loadingState = false;
            }).catch((error) => {
                this.loadingState = false;
                this.notify(_.get(errorMessages,'ajaxfailure'),'negative','fas fa-exclamation-triangle');
            })
        },
        onDialogShow(evt){
            this.captchaVerified = false;
            this.newCaptcha();
        },
        addSmiley (url,code) {
            const edit = this.$refs.comments;
            this.$refs.smileys.hide();
            edit.caret.restore();
            edit.runCmd('insertHTML', `<img class="gbsmiley" src="${url}" alt="${code}" />`);
            edit.focus();
        },
        onSubmit(){
            this.validateForm().then(() => {
                if(_.findKey(this.formerrors, ['isValid', false])){
                    return;
                }
                let formvalues = _.clone(this.gbform);
                let div = document.createElement('div');
                div.innerHTML = formvalues.comments;
                let smileyimages = div.querySelectorAll("img.gbsmiley");
                for (let i = 0; i < smileyimages.length; i++) {
                    smileyimages[i].parentNode.replaceChild(document.createTextNode(smileyimages[i].getAttribute("alt")), smileyimages[i]);
                }
                formvalues.comments = div.innerHTML;
                this.$refs.addEntryDialog.show();

                axios({
                    method: 'post',
                    url: gbURL + '/Ajax/addentry',
                    data: formvalues,
                    transformRequest: [
                        function(data, headers) {
                            return Object.keys(data).map((key) => {
                                return encodeURIComponent(key) + '=' + encodeURIComponent(data[key]);
                            }).join('&');
                        }
                    ]
                }).then((response) => {
                    console.log(response);
                    if(response.data['success']){
                        this.$refs.addEntryDialog.hide();
                        this.$refs.formDialog.hide();
                        this.notify(response.data['success'],'positive','fas fa-check');
                        this.loadGuestbookPage(1);
                    }else if(response.data['error']){
                        this.$refs.addEntryDialog.hide();
                        this.notify(response.data['error'],'negative','fas fa-exclamation-triangle');
                    }
                }).catch((error) => {
                    this.$refs.addEntryDialog.hide();
                    this.notify(error.toString(),'negative','fas fa-exclamation-triangle');
                })
            });

        },
        newCaptcha(){
            let tempDate = new Date();
            let tempTime = tempDate.getTime();
            this.captchaurl = gbURL + '/Ajax/captcha?reload='+ tempTime;
        },
        validateForm(){
            return new Promise((resolve, reject) => {
                this.validateName(this.gbform.fullname);
                this.validateEmail(this.gbform.email);
                this.validateWebsite(this.gbform.website);
                this.validateComments();
                this.verifyCaptcha().then(()=>{
                    resolve();
                })
            });
        },
        notify(message, color="primary", icon = "fas fa-info-circle"){
            if(this.notifyhandler) this.notifyhandler();

            this.notifyhandler = this.$q.notify({
                color: color,
                icon: icon,
                position: 'top',
                html: true,
                message: message,
                actions: [{ icon: 'fas fa-times', color: 'white' }],
                timeout: 7000
            })
        },
        validateName(val) {
            this.formerrors['fullname'].isValid = true;
            this.formerrors['fullname'].message = '';

            let regexName=/^[a-z ]+$/i;
            if(val !== ""){
                if(!regexName.test(val)) {
                    this.formerrors.fullname.isValid = false;
                    this.formerrors.fullname.message = getErrorString(formSignUp['FieldName'], 'alpha');
                }
            } else {
                if(this.requiredFileds['gb_name']){
                    this.formerrors.fullname.isValid = false;
                    this.formerrors.fullname.message = getErrorString(formSignUp['FieldName'], 'notEmpty');
                }
            }
        },
        validateEmail(val) {
            this.formerrors['email'].isValid = true;
            this.formerrors['email'].message = '';

            let regexEmail=/^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
            if(val !== ""){
                if(!regexEmail.test(val)) {
                    this.formerrors.email.isValid = false;
                    this.formerrors.email.message = getErrorString(formSignUp['FieldEmail'], 'email');
                }
            } else {
                if(this.requiredFileds['gb_email']){
                    this.formerrors.email.isValid = false;
                    this.formerrors.email.message = getErrorString(formSignUp['FieldEmail'], 'notEmpty');
                }
            }
        },
        validateWebsite(val) {
            this.formerrors['website'].isValid = true;
            this.formerrors['website'].message = '';

            let regexWeb=/(http|https):\/\/[\w\-_]+(\.[\w\-_]+)+([\w\-\.,@?^=%&amp;:/~\+#]*[\w\-\@?^=%&amp;/~\+#])?/;
            if(val !== ""){
                if(!regexWeb.test(val)) {
                    this.formerrors.website.isValid = false;
                    this.formerrors.website.message = getErrorString(formSignUp['FieldWebsite'], 'url');
                }
            } else {
                if(this.requiredFileds['gb_website']){
                    this.formerrors.website.isValid = false;
                    this.formerrors.website.message = getErrorString(formSignUp['FieldWebsite'], 'notEmpty');
                }
            }
        },
        validateComments(){
            this.formerrors['comments'].isValid = true;
            this.formerrors['comments'].message = '';

            let commentval = _.clone(this.gbform).comments;
            let div = document.createElement('div');
            div.innerHTML = commentval;
            commentval = div.textContent || div.innerText || "";

            if(this.requiredFileds['gb_comments']){
                if(commentval.length < minMessageLength) {
                    this.formerrors.comments.isValid = false;
                    this.formerrors.comments.message = getErrorString(formSignUp['FieldComments'], 'length.lower', minMessageLength);
                } else if(maxMessageLength > 0 &&  commentval.length > maxMessageLength) {
                    this.formerrors.comments.isValid = false;
                    this.formerrors.comments.message = getErrorString(formSignUp['FieldComments'], 'length.greater', null, maxMessageLength)
                }
            }
        },
        verifyCaptcha: function(){
            this.formerrors['captchacode'].isValid = true;
            this.formerrors['captchacode'].message = '';
            return new Promise((resolve, reject) => {
                if(this.requiredFileds.captcha && !this.captchaVerified){
                    axios({
                        method: 'post',
                        url: gbURL + '/Ajax/verifycaptcha',
                        data: {captchacode: this.gbform.captchacode},
                        transformRequest: [
                            function(data, headers) {
                                return Object.keys(data).map((key) => {
                                    return encodeURIComponent(key) + '=' + encodeURIComponent(data[key]);
                                }).join('&');
                            }
                        ]
                    }).then((response) => {
                        if(response.data['success'] === true){
                            this.captchaVerified = true;
                        }else{
                            this.formerrors.captchacode.isValid = false;
                            this.formerrors.captchacode.message = getErrorString(formSignUp['FieldCaptcha'], 'captcha');
                        }
                        resolve();
                    }).catch((error) => {
                        this.notify(error.toString(),'negative','fas fa-exclamation-triangle');
                        resolve();
                    })
                } else {
                    resolve();
                }
            });
        }
    },
    watch: {
        currentPage: function (val) {
            this.loadGuestbookPage(val);
        },
        'gbform.fullname': function (val) {
            this.validateName(val);
        },
        'gbform.email': function (val) {
            this.validateEmail(val);
        },
        'gbform.website': function (val) {
            this.validateWebsite(val);
        },
        'gbform.captchacode': function () {
            this.verifyCaptcha();
        }
    },
    mounted () {
        this.$nextTick(function () {
            this.captchaurl = gbURL + '/Ajax/captcha';
        })
    }
});