/**
 * @license Copyright (c) 2003-2016, CKSource - Frederico Knabben. All rights reserved.
 * For licensing, see LICENSE.md or http://ckeditor.com/license
 */

CKEDITOR.editorConfig = function( config ) {
	config.toolbarGroups = [
		{ name: 'clipboard', groups: [ 'clipboard', 'undo' ] },
		{ name: 'basicstyles', groups: [ 'basicstyles', 'cleanup' ] },
		{ name: 'styles', groups: [ 'styles' ] },
		{ name: 'colors', groups: [ 'colors' ] },
		'/',
		{ name: 'links', groups: [ 'links' ] },
		{ name: 'insert', groups: [ 'insert' ] },
		{ name: 'paragraph', groups: [ 'list', 'blocks' ] },
		{ name: 'document', groups: [ 'mode' ] }
	];

	config.removeButtons = 'Save,NewPage,Preview,Print,PasteText,PasteFromWord,Find,Replace,Scayt,SelectAll,Form,Checkbox,Radio,TextField,Textarea,Select,Button,ImageButton,HiddenField,Outdent,Indent,CreateDiv,JustifyLeft,JustifyCenter,JustifyRight,JustifyBlock,Subscript,Superscript,Strike,BidiLtr,BidiRtl,Language,Anchor,Flash,Table,HorizontalRule,PageBreak,Iframe,Styles,Format,Font,Maximize,ShowBlocks,About,SpecialChar,Templates';
	config.disableObjectResizing = true;
	config.baseFloatZIndex = 100400;
	config.width = '100%';
	config.resize_dir = 'vertical';
	
	config.smiley_columns = 6;
	config.smiley_path = smileyPath;
							
	config.smiley_descriptions = emcodes;
	config.smiley_images = emfiles;
	config.forcePasteAsPlainText = true;
	config.removePlugins = 'liststyle,tabletools,scayt,contextmenu';
	config.enterMode = CKEDITOR.ENTER_BR;
	config.shiftEnterMode = CKEDITOR.ENTER_P;
	config.entities = false;
	config.allowedContent = true;
	config.extraPlugins = 'fontawesome5';
	config.fontawesome : {
		'path': fontawsomepath,
		'version': '5.13.0',
		'edition': 'free',
		'element': 'i'
		}
};

CKEDITOR.on( 'dialogDefinition', function( ev )
{
	// Take the dialog name and its definition from the event data.
	var dialogName = ev.data.name;
	var dialogDefinition = ev.data.definition;

	// Check if the definition is from the dialog we're
	// interested in (the 'image' dialog). This dialog name found using DevTools plugin
	if ( dialogName == 'image' )
	{
		// Remove the 'Link' and 'Advanced' tabs from the 'Image' dialog.
		dialogDefinition.removeContents( 'Link' );
		dialogDefinition.removeContents( 'advanced' );

		// Get a reference to the 'Image Info' tab.
		var infoTab = dialogDefinition.getContents( 'info' );

		// Remove unnecessary widgets/elements from the 'Image Info' tab.
		infoTab.remove( 'txtHSpace');
		infoTab.remove( 'txtVSpace');
		infoTab.remove( 'txtHeight');
		infoTab.remove( 'txtWidth');
		infoTab.remove( 'cmbAlign');
		infoTab.remove( 'txtBorder');
		infoTab.remove( 'ratioLock');
	}
	else if ( dialogName == 'link' )
	{
		// Remove 'Advanced' tabs from the 'Link' dialog.
		dialogDefinition.removeContents( 'advanced' );
	}
});